using System;
using System.Linq;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;
using ILoan.Rules.Web.Models.Rules;

namespace ILoan.Rules.Web.Data
{
    public partial class RulesContext : DbContext
    {
        public RulesContext()
        {
        }

        public RulesContext(DbContextOptions<RulesContext> options) : base(options)
        {
        }

        partial void OnModelBuilding(ModelBuilder builder);

        protected override void OnModelCreating(ModelBuilder builder)
        {
            base.OnModelCreating(builder);

            builder.Entity<ILoan.Rules.Web.Models.Rules.CoreRuleCriteriaOperator>()
              .HasOne(i => i.CoreRule)
              .WithMany(i => i.CoreRuleCriteriaOperators)
              .HasForeignKey(i => i.RuleID)
              .HasPrincipalKey(i => i.ID);

            builder.Entity<ILoan.Rules.Web.Models.Rules.CoreRuleCriterion>()
              .HasOne(i => i.CoreRule)
              .WithMany(i => i.CoreRuleCriteria)
              .HasForeignKey(i => i.RuleID)
              .HasPrincipalKey(i => i.ID);

            builder.Entity<ILoan.Rules.Web.Models.Rules.CoreRule>()
              .Property(p => p.UseLastRecord)
              .HasDefaultValueSql(@"true");

            builder.Entity<ILoan.Rules.Web.Models.Rules.CoreRuleCriterion>()
              .Property(p => p.ValueIsProperty)
              .HasDefaultValueSql(@"false");

            builder.Entity<ILoan.Rules.Web.Models.Rules.CoreRuleCriterion>()
              .Property(p => p.ReturnCount)
              .HasDefaultValueSql(@"false");

            builder.Entity<ILoan.Rules.Web.Models.Rules.CoreRuleCriterion>()
              .Property(p => p.IsThresholdCriterium)
              .HasDefaultValueSql(@"false");
            this.OnModelBuilding(builder);
        }

        public DbSet<ILoan.Rules.Web.Models.Rules.CoreRuleCriteriaOperator> CoreRuleCriteriaOperators { get; set; }

        public DbSet<ILoan.Rules.Web.Models.Rules.CoreRule> CoreRules { get; set; }

        public DbSet<ILoan.Rules.Web.Models.Rules.CoreRuleCriterion> CoreRuleCriteria { get; set; }

        protected override void ConfigureConventions(ModelConfigurationBuilder configurationBuilder)
        {
            configurationBuilder.Conventions.Add(_ => new BlankTriggerAddingConvention());
        }
    }
}